<?php


namespace OrganizationsManagement\Api\ContractedModules\Controllers;

use Exception;
use OrganizationsManagement\Api\ContractedModules\Services\ContractedModules as ContractedModulesService;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class ContractedModules
{
    /**
     * @var ContractedModulesService
     */
    private $contractedModulesService;

    public function __construct(ContractedModulesService $contractedModulesService)
    {
        $this->contractedModulesService = $contractedModulesService;
    }

    /**
     * @param Request $request
     * @param Response $response
     */
    public function findModules(Request $request, Response $response)
    {
        try {
            $organizationId = $request->getParameter('ORGANIZATION_ID');
            $productId = $request->getParameter('PRODUCT_ID');
            $filterDtValidade = isset($request->getParameters()['FILTER_DTVALIDADE']) ? $request->getParameter('FILTER_DTVALIDADE') : 'N';
            $data = $this->contractedModulesService->findModules($organizationId, $productId, $filterDtValidade);
            $response->addDataSet(new DataSet('data', $data));
        } catch (Exception $ex) {
            $response->addMessage(new Message($ex->getMessage()));
            $response->setError(new Error($ex->getMessage(), $ex->getCode()));
        }
    }
}
