<?php
namespace OrganizationsManagement\Factory;
use Doctrine\ORM\EntityManager;
use OrganizationsManagement\Util\Utilities;
use Teknisa\Model\Teknisa\Entities\OmIpRestriction as IpRestrictionEntity;

class IpRestriction {
    public function save(IpRestrictionEntity $ipRestriction = null, $orgId, $currentOrgId, $codOperador, $dateNow,
                         $description, $ipv4, $ipv6, $active, EntityManager $entityManager = null) {
        if ($ipRestriction === null){
            $connection    = $entityManager ? $entityManager->getConnection() : null;
            $ipRestriction = new IpRestrictionEntity;
            $novoCodigo    = Utilities::generateNewCode($orgId, "OmIpRestriction", 1, 10, true, false, $connection);
            $ipRestriction->setCdoperinclusao($codOperador);
            $ipRestriction->setNrIpRestriction($novoCodigo);
            $ipRestriction->setNrorginclusao($currentOrgId);
            $ipRestriction->setDtinclusao($dateNow);
            $ipRestriction->setNrorg($orgId);
        }
        $ipRestriction->setDsObsIpRestricted($description);
        $ipRestriction->setNrorgultatu($currentOrgId);
        $ipRestriction->setCdoperultatu($codOperador);
        $ipRestriction->setDsIpv6Restricted($ipv6);
        $ipRestriction->setDsIpv4Restricted($ipv4);
        $ipRestriction->setDtultatu($dateNow);
        $ipRestriction->setIdativo($active);
        
        return $ipRestriction;
    }
}
