/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_LUSO                                                     */
/* Tabela : LICENCAUSO                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_LUSO
BEFORE INSERT OR UPDATE OR DELETE
ON LICENCAUSO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATULUSO := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMFANTLUSO,0)   <> NVL(:NEW.NMFANTLUSO,0))   OR
         (NVL(:OLD.NRINSESTLUSO,0) <> NVL(:NEW.NRINSESTLUSO,0)) OR
         (NVL(:OLD.DSENDELUSO,0)   <> NVL(:NEW.DSENDELUSO,0))   OR
         (NVL(:OLD.NMBAIRLUSO,0)   <> NVL(:NEW.NMBAIRLUSO,0))   OR
         (NVL(:OLD.NRCEPLUSO,0)    <> NVL(:NEW.NRCEPLUSO,0))    OR
         (NVL(:OLD.NRTELELUSO,0)   <> NVL(:NEW.NRTELELUSO,0))   OR
         (NVL(:OLD.SGESTADO,0)     <> NVL(:NEW.SGESTADO,0))     OR
         (NVL(:OLD.CDPAIS,0)       <> NVL(:NEW.CDPAIS,0))       OR
         (NVL(:OLD.CDLOCALUSO,0)   <> NVL(:NEW.CDLOCALUSO,0))   OR
         (NVL(:OLD.NRLICENCAUSO,0) <> NVL(:NEW.NRLICENCAUSO,0)) OR
         (NVL(:OLD.IDTPIJURLUSO,0) <> NVL(:NEW.IDTPIJURLUSO,0)) OR
         (NVL(:OLD.NRINSJURLUSO,0) <> NVL(:NEW.NRINSJURLUSO,0)) OR
         (NVL(:OLD.CDMUNICIPIO,0)  <> NVL(:NEW.CDMUNICIPIO,0))  OR
         (NVL(:OLD.CDCLIENTE,0)    <> NVL(:NEW.CDCLIENTE,0))    OR
         (NVL(:OLD.CDLOCALUSO,0)   <> NVL(:NEW.CDLOCALUSO,0)) THEN
         :NEW.DTULTATULUSO := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('LICENCAUSO', '', 'CDCLIENTE='||:OLD.CDCLIENTE||';NRLICENCAUSO='||:OLD.NRLICENCAUSO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE LICENCAUSO MODIFY DTULTATULUSO DEFAULT SYSDATE
/
