/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: CUSTO_PRODCONS

Descrio:
Retorna o custo de um Produto em uma determinada data.

P_CDFILIAL     - Cdigo da Filial.
P_CDPRODUTO    - Cdigo do Produto.
P_NRTIPOCUST   - Nmero do Tipo de Custo (1 a 10)
P_DTREFERENCIA - Data do Custo.

TIPOS DE CUSTO:

01 Custo Mdio Lquido Atual
02 Custo Mdio Bruto Atual
03 Custo Mdio Lquido da poca
04 Custo Mdio Bruto da poca
05 Custo da ltima Compra (NF)
06 Custo de Cotao (Lista de Preos)
07 Custo da ltima compra(AF)
20 Custo Mdio Lquido Atual
21 Custo Mdio Lquido Atual
22 Custo Mdio Bruto Atual
23 Custo Mdio Bruto Atual
24 Custo Mdio Lquido da poca
25 Custo Mdio Lquido da poca
26 Custo Mdio Bruto da poca
27 Custo Mdio Bruto da poca
28 Custo da ltima Compra (NF)
29 Custo da ltima Compra (NF)
30 Custo de Cotao (Lista de Preos)
31 Custo de Cotao (Lista de Preos)
32 Custo da ltima Compra(AF)
33 Custo da ltima Compra(AF)
34 Custo Mdio Atualizado

@C:\WIN_V4\SQL\END_CONV\ORACLE\0318_ESTFUNO.SQL

Criao:
21/01/2004 - Alessandra Cristina

*/

CREATE OR REPLACE
FUNCTION CUSTO_PRODCONS
   (P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
    P_CDPRODUTO    IN PRODUTO.CDPRODUTO%TYPE,
    P_NRTIPOCUST   IN NUMBER,
    P_DTREFERENCIA IN DATE) RETURN NUMBER IS
BEGIN
   RETURN(CUSTO_PRODUTO(P_CDFILIAL, P_CDPRODUTO, P_NRTIPOCUST, P_DTREFERENCIA, SYSDATE));
END;
/
