/* Tabela TABELA: TABELA DE TABELA*/
/* Descrio: A trigger insere registros na tabela LOGOPERAVND a partir de alteraes na tabela TABELA */
/* Objetivo: Gerar um log que vai registrar as alteraes na TABELA,
             utilizando a tabela de Logs de Operaes do VND*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VND_TABELA' AND
                 TYPE   = 'TR' 	               AND
	              U.UID  = O.UID           AND
	              U.NAME = USER)
DROP TRIGGER LOG_VND_TABELA
GO


CREATE TRIGGER LOG_VND_TABELA
ON TABELA
FOR INSERT, UPDATE, DELETE
AS
  DECLARE @V_DSREMOTEADDR VARCHAR(15);
  DECLARE @V_DSREMOTEHOST VARCHAR(15);
  DECLARE @V_DSSERVERRDM  VARCHAR(20);
  DECLARE @V_DSSERVMETHOD VARCHAR(30);
  DECLARE @V_DSREMOTEOPER VARCHAR(12);
  DECLARE @V_DESC         VARCHAR(500);
  DECLARE @V_ITPESQ       VARCHAR(40);
  DECLARE @V_NMOPERADOR   VARCHAR(40);
  DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/

  DECLARE @V_ID_COMANDO    VARCHAR(1);

  DECLARE @V_NEW_NMTABELABD          varchar(30);
  DECLARE @V_NEW_IDCRIADOTAB         varchar(1);
  DECLARE @V_NEW_DSTABELABD          varchar(50);
  DECLARE @V_NEW_IDUTCALQTORC        char(1);

  DECLARE @V_OLD_NMTABELABD          varchar(30);
  DECLARE @V_OLD_IDCRIADOTAB         varchar(1);
  DECLARE @V_OLD_DSTABELABD          varchar(50);
  DECLARE @V_OLD_IDUTCALQTORC        char(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC   = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @P_NMUSUARIO = @V_NMOPERADOR OUTPUT;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, ' ');

   EXEC WEBTUNNING  @P_DSREMOTEADDR = @V_DSREMOTEADDR OUTPUT,
                    @P_DSREMOTEHOST = @V_DSREMOTEHOST OUTPUT,
                    @P_DSSERVERRDM  = @V_DSSERVERRDM OUTPUT,
                    @P_DSSERVMETHOD = @V_DSSERVMETHOD OUTPUT,
                    @P_DSREMOTEOPER = @V_DSREMOTEOPER OUTPUT;

   DECLARE C_CURSOR CURSOR FOR
     SELECT
     'D'   ID_COMANDO,
           NULL,NULL,NULL,NULL,
           NMTABELABD,
           IDCRIADOTAB,
           DSTABELABD,
           IDUTCALQTORC
     FROM
           DELETED
     WHERE     
           NMTABELABD NOT IN (SELECT NMTABELABD FROM INSERTED)
     UNION ALL

     SELECT
     'U'   IDCOMANDO,
           INSERTED.NMTABELABD,
           INSERTED.IDCRIADOTAB,
           INSERTED.DSTABELABD,
           INSERTED.IDUTCALQTORC,

           DELETED.NMTABELABD,
           DELETED.IDCRIADOTAB,
           DELETED.DSTABELABD,
           DELETED.IDUTCALQTORC
     FROM
           INSERTED,
           DELETED
     WHERE     
           INSERTED.NMTABELABD = DELETED.NMTABELABD
     UNION ALL

     SELECT
     'I'   IDCOMANDO,
           INSERTED.NMTABELABD,
           INSERTED.IDCRIADOTAB,
           INSERTED.DSTABELABD,
           INSERTED.IDUTCALQTORC,
           NULL,NULL,NULL,NULL
     FROM
           INSERTED
     WHERE     
           NMTABELABD NOT IN (SELECT NMTABELABD FROM DELETED)

     OPEN C_CURSOR;
     FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                   @V_NEW_NMTABELABD,@V_NEW_IDCRIADOTAB,@V_NEW_DSTABELABD,@V_NEW_IDUTCALQTORC,
                                   @V_OLD_NMTABELABD,@V_OLD_IDCRIADOTAB,@V_OLD_DSTABELABD,@V_OLD_IDUTCALQTORC

    WHILE (@@FETCH_STATUS = 0) BEGIN
    
       IF @V_ID_COMANDO= 'U' /*UPDATE*/ BEGIN
		IF ISNULL(@V_NEW_NMTABELABD,'NULL') <> ISNULL(@V_OLD_NMTABELABD,'NULL') BEGIN
			SET @V_DESC   = 'Nm Tabela ' + ISNULL(@V_NEW_NMTABELABD,'' );
		END;
		IF ISNULL(@V_NEW_IDCRIADOTAB,'NULL') <> ISNULL(@V_OLD_IDCRIADOTAB,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Id Criao Tabela ' + ISNULL(@V_NEW_IDCRIADOTAB,'');
		END;
		IF ISNULL(@V_NEW_DSTABELABD,'NULL') <> ISNULL(@V_OLD_DSTABELABD,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Ds Tabela ' + ISNULL(@V_NEW_DSTABELABD,'' );
		END;
		IF ISNULL(@V_NEW_IDUTCALQTORC,'NULL') <> ISNULL(@V_OLD_IDUTCALQTORC,'NULL') BEGIN
            SET @V_DESC  = ISNULL(@V_DESC,'') + '  Id Uti Calculo '    + ISNULL(@V_NEW_IDUTCALQTORC,'' );
		END;
        SET @V_IDTIPOOPER = '2';
       END;
       IF @V_ID_COMANDO= 'I' /*INSERO*/ BEGIN
          SET @V_DESC   = 'Nm Tabela '         + ISNULL(@V_NEW_NMTABELABD,'' )   + ' ' +
                      'Id Criao Tabela ' + ISNULL(@V_NEW_IDCRIADOTAB,'')   + ' ' +
                      'Ds Tabela '         + ISNULL(@V_NEW_DSTABELABD,'' )   + ' ' +
                      'Id Uti Calculo '    + ISNULL(@V_NEW_IDUTCALQTORC,'' );
          SET @V_IDTIPOOPER = '1';
       END;
       IF @V_ID_COMANDO= 'D' /*DELEO*/  BEGIN
          SET @V_DESC   = 'Nm Tabela '         + ISNULL(@V_OLD_NMTABELABD,'' )   + ' ' +
                      'Id Criao Tabela ' + ISNULL(@V_OLD_IDCRIADOTAB,'')   + ' ' +
                      'Ds Tabela '         + ISNULL(@V_OLD_DSTABELABD,'' )   + ' ' +
                      'Id Uti Calculo '    + ISNULL(@V_OLD_IDUTCALQTORC,'' );
          SET @V_IDTIPOOPER = '3';
       END;
       IF  (@V_IDTIPOOPER <> '') BEGIN
          IF @V_DESC IS NOT NULL BEGIN
             SET @V_ITPESQ =  ISNULL(@V_NEW_NMTABELABD ,@V_OLD_NMTABELABD );
             SET @V_DESC = SUBSTRING(@V_DESC, 1, 300);
             INSERT INTO LOGOPERAVND
                    (NMTABELAVND, DTOPERACAOVND, NMRESPOPERVND, IDTIPOOPERVND, DSOPERACAOVND,
                     CDPESQITEMVND, DSRDMUSUOPERVND, DSENDUSUOPERVND, DSNMUSUOPERVND, DSMETUSUOPERVND,
                     CDORESPOPERVND)
             VALUES ('TABELA',GETDATE(), ISNULL(@V_NMOPERADOR,' '), @V_IDTIPOOPER, @V_DESC, @V_ITPESQ,
                     @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
          END;
       END;
       FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                     @V_NEW_NMTABELABD,@V_NEW_IDCRIADOTAB,@V_NEW_DSTABELABD,@V_NEW_IDUTCALQTORC,
                                     @V_OLD_NMTABELABD,@V_OLD_IDCRIADOTAB,@V_OLD_DSTABELABD,@V_OLD_IDUTCALQTORC

    SET @V_DESC   = '';
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_VND_TABELA','5.20.001';
GO
