ALTER TABLE FCM_RESULTADOAUDIT DROP COLUMN NRCRITERIOAUDIT
/

ALTER TABLE FCM_RESULTADOAUDIT ADD NRCATEGORIAAUDIT  NUMBER  NOT NULL
/

ALTER TABLE FCM_RESULTADOAUDIT 
  ADD CONSTRAINT FKFCM00194CATEGAUDIT_RESULDIT FOREIGN KEY (NRCATEGORIAAUDIT)
      REFERENCES FCM_CATEGORIAAUDIT (NRCATEGORIAAUDIT)
/

CREATE INDEX FCM00194_FK ON FCM_RESULTADOAUDIT (NRCATEGORIAAUDIT)
/	

ALTER TABLE FCM_AUDITORIA ADD IDTIPOMARCACAO  VARCHAR(1)
/

ALTER TABLE FCM_AUDITORIA ADD CONSTRAINT CKC_IDTIPOMARCACAO_AUDITORIA
	CHECK (IDTIPOMARCACAO IN ('U', 'M'))
/

ALTER TABLE FCM_FOTORESULTAUDIT DROP COLUMN NRRESULTADOAUDIT
/

ALTER TABLE FCM_FOTORESULTAUDIT DROP COLUMN NRMODELOAUDIT
/

ALTER TABLE FCM_FOTORESULTAUDIT ADD NRCATEGORIAAUDIT  NUMBER  NOT NULL
/

ALTER TABLE FCM_FOTORESULTAUDIT 
  ADD CONSTRAINT FKFCM00195CATEGORIAAUDIT_FTRESULAUT FOREIGN KEY (NRCATEGORIAAUDIT)
      REFERENCES FCM_CATEGORIAAUDIT (NRCATEGORIAAUDIT)
/ 

CREATE INDEX FCM00195_FK ON FCM_RESULTADOAUDIT (NRCATEGORIAAUDIT)
/     

ALTER TABLE FCM_FOTORESULTAUDIT ADD NRAUDITORIA  NUMBER  NOT NULL
/

ALTER TABLE FCM_FOTORESULTAUDIT 
  ADD CONSTRAINT FKFCM00196AUDITORIA_FTRESUAUT FOREIGN KEY (NRAUDITORIA)
      REFERENCES FCM_AUDITORIA (NRAUDITORIA)
/

CREATE INDEX FCM00196_FK ON FCM_RESULTADOAUDIT (NRCATEGORIAAUDIT)
/

ALTER TABLE FCM_FOTORESULTAUDIT DROP COLUMN DSFOTOTAREFAAGEND
/

ALTER TABLE FCM_FOTORESULTAUDIT ADD DSFOTOAUDITORIA  VARCHAR2(1000) NOT NULL
/


CREATE TABLE FCM_RELACRESULTCRIT (
	NRRELACRESULTCRIT NUMBER  		  NOT NULL,
	NRRESULTADOAUDIT  NUMBER 		  NOT NULL,
	NRCRITERIOAUDIT	  NUMBER  		  NOT NULL,
	NRTOPICOAUDIT	  NUMBER 		  NOT NULL,
    IDREALIZADO       VARCHAR2(1) 	  DEFAULT 'N' NOT NULL,
	NRORG             NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        DATE            DEFAULT SYSDATE,
    DTULTATU          DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO     NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU       NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      VARCHAR2(12)    DEFAULT '1',
		CONSTRAINT CKC_IDATIVO_FCM_RELACSULCRIT CHECK (IDATIVO IN ('S','N'))
)
/

ALTER TABLE FCM_RELACRESULTCRIT ADD CONSTRAINT PK_FCM_RELACRESULTCRIT PRIMARY KEY (NRRELACRESULTCRIT)
/

ALTER TABLE FCM_RELACRESULTCRIT 
  ADD CONSTRAINT FKFCM00197RESULTAAUDI_RESUCRI FOREIGN KEY (NRRESULTADOAUDIT)
      REFERENCES FCM_RESULTADOAUDIT (NRRESULTADOAUDIT)
/ 

CREATE INDEX FCM00197_FK ON FCM_RELACRESULTCRIT (NRRESULTADOAUDIT)
/

ALTER TABLE FCM_RELACRESULTCRIT 
  ADD CONSTRAINT FKFCM00198CRITERAUDI_RESUCRI FOREIGN KEY (NRCRITERIOAUDIT)
      REFERENCES FCM_CRITERIOAUDIT (NRCRITERIOAUDIT)
/

CREATE INDEX FCM00198_FK ON FCM_RELACRESULTCRIT (NRCRITERIOAUDIT)
/ 
     
ALTER TABLE FCM_RELACRESULTCRIT 
  ADD CONSTRAINT FKFCM00199TOPCAUDI_RELRESUCRI FOREIGN KEY (NRTOPICOAUDIT)
      REFERENCES FCM_TOPICOAUDIT (NRTOPICOAUDIT)
/

CREATE INDEX FCM00199_FK ON FCM_RELACRESULTCRIT (NRTOPICOAUDIT)
/

ALTER TABLE FCM_RELACRESULTCRIT ADD CONSTRAINT CKC_IDATIVO_FCM_RELRESULTCRIT CHECK (IDATIVO IN ('S', 'N'))
/

ALTER TABLE FCM_RELACRESULTCRIT ADD CONSTRAINT CKC_IDREALIZADO_RELRESULTCRIT CHECK (IDREALIZADO IN ('S', 'N'))
/