<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaFerias extends \Doctrine\ORM\EntityRepository {
   
    public function retornaFeriasProvisao($nr_vinculo,$nrOrg,$dtultimodiames){
        
        $fpaFerias = Repositories::FPA_FERIAS;
        
        $params = array(
            'p_nrorg' => $nrOrg,
            'p_nrvinculo' => $nr_vinculo
        );
        
$sql = <<<SQL
    SELECT f
        FROM $fpaFerias f
        WHERE f.idcontrolferias <> ('GOZADO_INTEGRAL')
        AND f.nrorg              = :p_nrorg
        AND f.nrvinculom         = :p_nrvinculo
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        $params['p_dtultimodiames'] = $dtultimodiames;
        
$sql2 = <<<SQL
        SELECT f
        FROM $fpaFerias f
        WHERE f.idcontrolferias = 'GOZADO_INTEGRAL'
        AND f.nrorg             = :p_nrorg
        AND f.nrvinculom        = :p_nrvinculo
        AND f.dtiniaquisicao      =
          (SELECT MAX(fdt.dtiniaquisicao)
          FROM $fpaFerias fdt
          WHERE fdt.dtiniaquisicao <= :p_dtultimodiames
          AND fdt.nrvinculom        = :p_nrvinculo
          AND fdt.nrorg             = f.nrorg
          AND fdt.idcontrolferias   = 'GOZADO_INTEGRAL'
          )
SQL;

        $result2 = $this->getEntityManager()->createQuery($sql2)->execute($params);
        
        $resultado = array_merge($result,$result2);
        
        return $resultado;
    }
    
    public function getPeriodoGozoFerias($nrvinculom, $dtinicio, $dtfinal, $nrorg) {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = [
                    "p_nrvinculom" => $nrvinculom,
                    "p_dtinicio" => $dtinicio->format('d/m/Y'),
                    "p_dtfinal" => $dtfinal->format('t/m/Y'),
                    "p_nrorg" => $nrorg,
                  ];

$sql = <<<SQL
    SELECT
        ferias.nrorg,
        ferias.nrvinculom,
        gozof.dtinigozoferias,
        gozof.dtfimgozoferias,
        
        (CASE         
            WHEN ( gozof.dtinigozoferias < TO_DATE(:p_dtinicio) ) AND ( gozof.dtfimgozoferias < TO_DATE(:p_dtfinal) )             
                THEN gozof.dtfimgozoferias - TO_DATE(:p_dtinicio) + 1         
            
            WHEN ( gozof.dtinigozoferias>TO_DATE(:p_dtinicio) ) AND ( gozof.dtfimgozoferias > TO_DATE(:p_dtfinal) )             
                THEN TO_DATE(:p_dtfinal) + 1 - gozof.dtinigozoferias         
            
            WHEN ( gozof.dtinigozoferias>TO_DATE(:p_dtinicio) ) AND ( gozof.dtfimgozoferias < TO_DATE(:p_dtfinal) )             
                THEN gozof.dtfimgozoferias - gozof.dtinigozoferias + 1     
        
        END) quantidade 
    
    FROM
        FPA_FERIAS ferias 
    
    INNER JOIN
        FPA_GOZOFERIAS gozof     
            ON gozof.nrferias = ferias.nrferias     
            AND gozof.nrorg = ferias.nrorg 
    WHERE
        (
            gozof.dtinigozoferias BETWEEN TO_DATE(:p_dtinicio) - 1 AND :p_dtfinal     
            OR gozof.dtfimgozoferias BETWEEN TO_DATE(:p_dtinicio) - 1 AND :p_dtfinal
        )     
        AND ferias.nrvinculom = :p_nrvinculom     
        AND ferias.nrorg = :p_nrorg
SQL;

        $resultado = $db->fetchAll($sql,$params);
        
        if($resultado)
            return $resultado[0];
        else
            return false;
        
    }
    
    public function getSaldoFerias($nrorg, $nrvinculom, $dtinicio) {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = [
                    "P_NRORG"       => $nrorg,
                    "P_DTINICIO"    => $dtinicio,
                    "P_NRVINCULOM"  => $nrvinculom,
                  ];

$sql = <<<SQL
    SELECT
      QTDIASSALDO
    FROM
      FPA_FERIAS FERIAS
    WHERE FERIAS.NRORG      = :P_NRORG
      AND FERIAS.NRVINCULOM = :P_NRVINCULOM
      AND :P_DTINICIO BETWEEN FERIAS.DTINIAQUISICAO AND FERIAS.DTFIMAQUISICAO
SQL;

        $resultado = $db->fetchAll($sql,$params);
        
        if($resultado)
            return $resultado[0]['QTDIASSALDO'];
        else
            return 0;
        
    }
    
    
}